<template>
  <div>
    <CCard>
      <CCardHeader>
        <div>
          <font-awesome-icon :icon="['fas', 'lightbulb']" />
          <strong>Thing list</strong>
        </div>

        <div class="card-header-actions">
          <app-filter-button
            :data="data"
            @submit="onSearch"
          />
          <CButton
            color="primary"
            variant="ghost"
            :disabled="loading"
            @click="onShowDetail(0)"
          >
            <font-awesome-icon :icon="['fas', 'plus-circle']" class="width-1x" />
            Add thing
          </CButton>
        </div>
      </CCardHeader>

      <CCardBody>
        <thing-search-form
          :loading="loading"
          :default-condition="condition"
          @submit="onSearch"
        />

        <thing-table
          :loading="loading"
          :data="data"
          @delete="onConfirmDelete"
          @show-detail="onShowDetail"
          @modify="refresh"
        />

        <app-pagination
          :total="total"
          :page-size="limit"
          :current-page="page"
          :disabled="loading"
          @page-change="onPageChange"
        />
      </CCardBody>
    </CCard>

    <app-delete-confirm-dialog
      ref="deleteConfirmDialog"
      :name="'Thing'"
      @confirm="onDelete"
    />

    <thing-detail-modal
      :id="selectedId"
      ref="thingDetailModal"
      @modify="refresh"
    />
  </div>
</template>

<script>
import ThingTable from '~/components/organisms/things/ThingTable'
import ThingSearchForm from '~/components/organisms/things/ThingSearchForm'
import AppDeleteConfirmDialog from '~/components/molecules/AppDeleteConfirmDialog'
import AppFilterButton from '~/components/atoms/AppFilterButton'
import ThingDetailModal from '~/components/organisms/things/ThingDetailModal'
import AppPagination from '~/components/atoms/AppPagination'

import AsyncLoading from '~/mixins/do-async-loading'
import ConditionHandler from '~/mixins/condition'
import SearchFormHandler from '~/mixins/search-form'
import Paginator from '~/mixins/paginator'

export default {
  components: {
    ThingTable,
    ThingSearchForm,
    AppDeleteConfirmDialog,
    AppFilterButton,
    ThingDetailModal,
    AppPagination
  },

  mixins: [
    AsyncLoading,
    ConditionHandler,
    SearchFormHandler,
    Paginator
  ],

  data: () => {
    return {
      resourceTypeName: 'thing',
      total: 0,
      data: [],
      selectedId: null
    }
  },

  mounted () {
    this.refresh()
  },

  methods: {
    /**
     * Fetch thing data
     *
     */
    async fetch () {
      const res = await this.$dam.getThingList(this.query)
      if (Array.isArray(res.data) && res.data.length) {
        this.total = res.meta.total
        this.data = res.data
      }
    },

    /**
     * Open confirm delete
     * If confirm then call delete thing
     * Else cancel
     *
     * @param {Number} id - thing id
     */
    onConfirmDelete (id) {
      this.setSelectedId(id)
      this.$refs.deleteConfirmDialog.open()
    },

    /**
     * Call API delete.
     *
     * @param {Number} selectedId - User id
     */
    async delete (selectedId) {
      await this.$dam.deleteThing({ id: selectedId })
    },

    /**
     * Open thing detail modal
     *
     * @param {Number} id - Current id
     */
    onShowDetail (id) {
      this.setSelectedId(id)
      this.$refs.thingDetailModal.open()
    },

    /**
     * Set thing select id
     *
     * @param {Number} id - Current id
     */
    setSelectedId (id) {
      this.selectedId = id
    }
  }
}
</script>

<style>
  .btn-custom{
    justify-content: center
  }
</style>
